/* Menu.h -- This file contains definitions that give semantic names to
             buttons within the application's menus.  */

/***   Button Types   ***/
#define  PushButton         0
#define  CheckBox           1
#define  CheckBoxOn         2
#define  RadioButton        3
#define  RadioButtonOn      4
#define  CascadeButton      5

/***   Menu Commands   ***/
#define MENU_File_New           101
#define MENU_File_Open          102
#define MENU_File_Save          103
#define MENU_File_SaveAs        104
#define MENU_File_Print         105
#define MENU_File_Exit          106

#define MENU_Edit_Undo          201
#define MENU_Edit_Cut           202
#define MENU_Edit_Copy          203
#define MENU_Edit_Paste         204
#define MENU_Edit_Clear         205
#define MENU_Edit_Delete        206

#define MENU_View_AsOne         301
#define MENU_View_AsTwo         302
#define MENU_View_AsThree       303

#define MENU_checkbox_A         401
#define MENU_checkbox_B         402
#define MENU_checkbox_C         403
#define MENU_radio_1            404
#define MENU_radio_2            405
#define MENU_radio_3            406

/* new */
#define MENU_Printer_Switch     501
/* end new */

#define MENU_Help_OnItem        901
#define MENU_Help_OnApplication 902
#define MENU_Help_OnHelp        903
#define MENU_Help_Index         904
#define MENU_Help_Tutorial      905
#define MENU_Help_OnVersion     906
