#include <Xm/RowColumn.h>
#include <Xm/PushB.h>

/***********************************************************************
 ***                             MAIN                                ***
 ***********************************************************************/
void main(argc, argv)
  unsigned int argc;
  char **argv;
{
   Widget toplevel, rc, pbutton[6];
   Arg args[10];
   XtAppContext app_context;
   static char * pbname[] = {"pb1", "pb2", "pb3", "pb4", "pb5", "pb6"};
   int i, n;
     
/* Initialize the toolkit, create app context, open display,
   and create a toplevel shell  */
   toplevel = XtAppInitialize(&app_context, "Rcdemo", NULL, 0, &argc,
   argv, NULL, args, 0);

/* Create the row column widget */
   n = 0;
   XtSetArg (args[n], XmNnumColumns, 3); n++;
   XtSetArg (args[n], XmNpacking, XmPACK_COLUMN); n++;
   rc = XmCreateRowColumn(toplevel, "rc", args, n);
   XtManageChild(rc);

/* Create the 6 push button widgets. */
   for (i = 0; i < XtNumber(pbname); i++)
      pbutton[i] = XmCreatePushButton(rc, pbname[i], args, 0);
   XtManageChildren(pbutton, XtNumber(pbutton));

/* Realize the widgets and loop  */
   XtRealizeWidget(toplevel);
   XtAppMainLoop(app_context);
}
